# This file is generated by numpy's build process
# It contains system_info results at the time of building this package.
from enum import Enum
from numpy._core._multiarray_umath import (
    __cpu_features__,
    __cpu_baseline__,
    __cpu_dispatch__,
)

__all__ = ["show"]
_built_with_meson = True


class DisplayModes(Enum):
    stdout = "stdout"
    dicts = "dicts"


def _cleanup(d):
    """
    Removes empty values in a `dict` recursively
    This ensures we remove values that Meson could not provide to CONFIG
    """
    if isinstance(d, dict):
        return {k: _cleanup(v) for k, v in d.items() if v and _cleanup(v)}
    else:
        return d


CONFIG = _cleanup(
    {
        "Compilers": {
            "c": {
                "name": "gcc",
                "linker": r"ld.bfd",
                "version": "14.3.0",
                "commands": r"gcc",
                "args": r"-pipe, -Wno-error, -fstack-protector-strong, --param=ssp-buffer-size=4, -fexceptions, -ggdb, -fira-loop-pressure, -fira-hoist-pressure, -specs=/usr/lib/gcc/specs/hardened-cc1, -O2, -fno-omit-frame-pointer, -flto=auto, -ffat-lto-objects, -mabi=lp64d, -mno-strict-align, -march=la64v1.0, -mtune=la664, -D_GLIBCXX_ASSERTIONS, -U_FORTIFY_SOURCE, -D_FORTIFY_SOURCE=3",
                "linker args": r"-Wl,-O1,--sort-common,--as-needed, -Wl,-build-id=sha1, -Wl,-z,relro, -Wl,-z,now, -specs=/usr/lib/gcc/specs/hardened-ld, -flto, -fuse-linker-plugin, -pipe, -Wno-error, -fstack-protector-strong, --param=ssp-buffer-size=4, -fexceptions, -ggdb, -fira-loop-pressure, -fira-hoist-pressure, -specs=/usr/lib/gcc/specs/hardened-cc1, -O2, -fno-omit-frame-pointer, -flto=auto, -ffat-lto-objects, -mabi=lp64d, -mno-strict-align, -march=la64v1.0, -mtune=la664, -D_GLIBCXX_ASSERTIONS, -U_FORTIFY_SOURCE, -D_FORTIFY_SOURCE=3",
            },
            "cython": {
                "name": "cython",
                "linker": r"cython",
                "version": "3.1.0",
                "commands": r"cython",
                "args": r"",
                "linker args": r"",
            },
            "c++": {
                "name": "gcc",
                "linker": r"ld.bfd",
                "version": "14.3.0",
                "commands": r"g++",
                "args": r"-ggdb, -fpermissive, -fdeclone-ctor-dtor, -pipe, -Wno-error, -fstack-protector-strong, --param=ssp-buffer-size=4, -fexceptions, -ggdb, -fira-loop-pressure, -fira-hoist-pressure, -specs=/usr/lib/gcc/specs/hardened-cc1, -O2, -fno-omit-frame-pointer, -flto=auto, -ffat-lto-objects, -mabi=lp64d, -mno-strict-align, -march=la64v1.0, -mtune=la664, -D_GLIBCXX_ASSERTIONS, -U_FORTIFY_SOURCE, -D_FORTIFY_SOURCE=3",
                "linker args": r"-Wl,-O1,--sort-common,--as-needed, -Wl,-build-id=sha1, -Wl,-z,relro, -Wl,-z,now, -specs=/usr/lib/gcc/specs/hardened-ld, -flto, -fuse-linker-plugin, -ggdb, -fpermissive, -fdeclone-ctor-dtor, -pipe, -Wno-error, -fstack-protector-strong, --param=ssp-buffer-size=4, -fexceptions, -ggdb, -fira-loop-pressure, -fira-hoist-pressure, -specs=/usr/lib/gcc/specs/hardened-cc1, -O2, -fno-omit-frame-pointer, -flto=auto, -ffat-lto-objects, -mabi=lp64d, -mno-strict-align, -march=la64v1.0, -mtune=la664, -D_GLIBCXX_ASSERTIONS, -U_FORTIFY_SOURCE, -D_FORTIFY_SOURCE=3",
            },
        },
        "Machine Information": {
            "host": {
                "cpu": "loongarch64",
                "family": "loongarch64",
                "endian": "little",
                "system": "linux",
            },
            "build": {
                "cpu": "loongarch64",
                "family": "loongarch64",
                "endian": "little",
                "system": "linux",
            },
            "cross-compiled": bool("False".lower().replace("false", "")),
        },
        "Build Dependencies": {
            "blas": {
                "name": "openblas",
                "found": bool("True".lower().replace("false", "")),
                "version": "0.3.29",
                "detection method": "pkgconfig",
                "include directory": r"/var/cache/acbs/build/acbs.3b436aj3/openblas/abdist/usr/include",
                "lib directory": r"/var/cache/acbs/build/acbs.3b436aj3/openblas/abdist/usr/lib",
                "openblas configuration": r"USE_64BITINT= DYNAMIC_ARCH= DYNAMIC_OLDER= NO_CBLAS= NO_LAPACK= NO_LAPACKE= NO_AFFINITY=1 USE_OPENMP= generic MAX_THREADS=32",
                "pc file directory": r"/usr/lib/pkgconfig",
            },
            "lapack": {
                "name": "openblas",
                "found": bool("True".lower().replace("false", "")),
                "version": "0.3.29",
                "detection method": "pkgconfig",
                "include directory": r"/var/cache/acbs/build/acbs.3b436aj3/openblas/abdist/usr/include",
                "lib directory": r"/var/cache/acbs/build/acbs.3b436aj3/openblas/abdist/usr/lib",
                "openblas configuration": r"USE_64BITINT= DYNAMIC_ARCH= DYNAMIC_OLDER= NO_CBLAS= NO_LAPACK= NO_LAPACKE= NO_AFFINITY=1 USE_OPENMP= generic MAX_THREADS=32",
                "pc file directory": r"/usr/lib/pkgconfig",
            },
        },
        "Python Information": {
            "path": r"/usr/bin/python3",
            "version": "3.10",
        },
        "SIMD Extensions": {
            "baseline": __cpu_baseline__,
            "found": [
                feature for feature in __cpu_dispatch__ if __cpu_features__[feature]
            ],
            "not found": [
                feature for feature in __cpu_dispatch__ if not __cpu_features__[feature]
            ],
        },
    }
)


def _check_pyyaml():
    import yaml

    return yaml


def show(mode=DisplayModes.stdout.value):
    """
    Show libraries and system information on which NumPy was built
    and is being used

    Parameters
    ----------
    mode : {`'stdout'`, `'dicts'`}, optional.
        Indicates how to display the config information.
        `'stdout'` prints to console, `'dicts'` returns a dictionary
        of the configuration.

    Returns
    -------
    out : {`dict`, `None`}
        If mode is `'dicts'`, a dict is returned, else None

    See Also
    --------
    get_include : Returns the directory containing NumPy C
                  header files.

    Notes
    -----
    1. The `'stdout'` mode will give more readable
       output if ``pyyaml`` is installed

    """
    if mode == DisplayModes.stdout.value:
        try:  # Non-standard library, check import
            yaml = _check_pyyaml()

            print(yaml.dump(CONFIG))
        except ModuleNotFoundError:
            import warnings
            import json

            warnings.warn("Install `pyyaml` for better output", stacklevel=1)
            print(json.dumps(CONFIG, indent=2))
    elif mode == DisplayModes.dicts.value:
        return CONFIG
    else:
        raise AttributeError(
            f"Invalid `mode`, use one of: {', '.join([e.value for e in DisplayModes])}"
        )
